Package net.sf.saxon.pull

## Interface PullProvider

- All Known Subinterfaces:
    `UnfailingPullProvider`
  All Known Implementing Classes:
    `DocumentWrappingPullProvider`, `ElementNameTracker`, `PullFilter`, `PullFromIterator`, `PullNamespaceReducer`, `PullPushTee`, `PullTracer`, `StaxBridge`, `TreeWalker`

      public interface PullProvider

  PullProvider is Saxon's pull-based interface for reading XML documents and XDM sequences. A PullProvider can deliver any sequence of nodes or atomic values. An atomic value in the sequence is delivered as a single event; a node is delivered as a sequence of events equivalent to a recursive walk of the XML tree. Within this sequence, the start and end of a document, or of an element, are delivered as separate events; other nodes are delivered as individual events.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `PullProvider.Event` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the event reader.
    `PullProvider.Event` | `current()` | Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd().
    `AtomicValue` | `getAtomicValue()` | Get an atomic value.
    `AttributeMap` | `getAttributes()` | Get the attributes associated with the current element.
    `NamespaceBinding[]` | `getNamespaceDeclarations()` | Get the namespace declarations associated with the current element.
    `NodeName` | `getNodeName()` | Get the NodeName identifying the name of the current node.
    `PipelineConfiguration` | `getPipelineConfiguration()` | Get configuration information.
    `SchemaType` | `getSchemaType()` | Get the type annotation of the current attribute or element node, or atomic value.
    `Location` | `getSourceLocator()` | Get the location of the current event.
    `java.lang.CharSequence` | `getStringValue()` | Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.
    `java.util.List<UnparsedEntity>` | `getUnparsedEntities()` | Get a list of unparsed entities.
    `PullProvider.Event` | `next()` | Get the next event
    `void` | `setPipelineConfiguration​(PipelineConfiguration pipe)` | Set configuration information.
    `PullProvider.Event` | `skipToMatchingEnd()` | Skip the current subtree.

- - ### Method Detail

    - #### setPipelineConfiguration

          void setPipelineConfiguration​(PipelineConfiguration pipe)

      Set configuration information. This must only be called before any events have been read.
      Parameters:
        `pipe` - the pipeline configuration

    - #### getPipelineConfiguration

          PipelineConfiguration getPipelineConfiguration()

      Get configuration information.
      Returns:
        the pipeline configuration

    - #### next

          PullProvider.Event next()
                           throws XPathException

      Get the next event
      Returns:
        an Event object indicating the type of event. The code `PullProvider.Event.END_OF_INPUT` is returned at the end of the sequence.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### current

          PullProvider.Event current()

      Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd(). This method does not change the position of the PullProvider.
      Returns:
        the current event

    - #### getAttributes

          AttributeMap getAttributes()
                              throws XPathException

      Get the attributes associated with the current element. This method must be called only after a START_ELEMENT event has been notified. The contents of the returned AttributeMap are immutable.

      Attributes may be read before or after reading the namespaces of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToMatchingEnd(), getStringValue(), or getTypedValue().

      Returns:
        an AttributeMap representing the attributes of the element that has just been notified.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getNamespaceDeclarations

          NamespaceBinding[] getNamespaceDeclarations()
                                               throws XPathException

      Get the namespace declarations associated with the current element. This method must be called only after a START_ELEMENT event has been notified. In the case of a top-level START_ELEMENT event (that is, an element that either has no parent node, or whose parent is not included in the sequence being read), the NamespaceDeclarations object returned will contain a namespace declaration for each namespace that is in-scope for this element node. In the case of a non-top-level element, the NamespaceDeclarations will contain a set of namespace declarations and undeclarations, representing the differences between this element and its parent.

      It is permissible for this method to return namespace declarations that are redundant.

      The NamespaceDeclarations object is guaranteed to remain unchanged until the next START_ELEMENT event, but may then be overwritten. The object should not be modified by the client.

      Namespaces may be read before or after reading the attributes of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToMatchingEnd(), getStringValue(), or getTypedValue().

      Returns:
        the namespace declarations associated with the current START_ELEMENT event.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### skipToMatchingEnd

          PullProvider.Event skipToMatchingEnd()
                                        throws XPathException

      Skip the current subtree. This method may be called only immediately after a START_DOCUMENT or START_ELEMENT event. This call returns the matching END_DOCUMENT or END_ELEMENT event; the next call on next() will return the event following the END_DOCUMENT or END_ELEMENT.
      Returns:
        the matching END_DOCUMENT or END_ELEMENT event
      Throws:
        `java.lang.IllegalStateException` - if the method is called at any time other than immediately after a START_DOCUMENT or START_ELEMENT event.
        `XPathException` - if a dynamic error occurs

    - #### close

          void close()

      Close the event reader. This indicates that no further events are required. It is not necessary to close an event reader after `PullProvider.Event.END_OF_INPUT` has been reported, but it is recommended to close it if reading terminates prematurely. Once an event reader has been closed, the effect of further calls on next() is undefined.

    - #### getNodeName

          NodeName getNodeName()

      Get the NodeName identifying the name of the current node. This method can be used after the `PullProvider.Event.START_ELEMENT`, `PullProvider.Event.PROCESSING_INSTRUCTION`, `PullProvider.Event.ATTRIBUTE`, or `PullProvider.Event.NAMESPACE` events. With some PullProvider implementations, it can also be used after `PullProvider.Event.END_ELEMENT`, but this is not guaranteed. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is null.
      Returns:
        the NodeName. The NodeName can be used to obtain the prefix, local name, and namespace URI.

    - #### getStringValue

          java.lang.CharSequence getStringValue()
                                         throws XPathException

      Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.

      In other situations the result is undefined and may result in an IllegalStateException.

      If the most recent event was a `PullProvider.Event.START_ELEMENT`, this method causes the content of the element to be read. The current event on completion of this method will be the corresponding `PullProvider.Event.END_ELEMENT`. The next call of next() will return the event following the END_ELEMENT event.

      Returns:
        the String Value of the node in question, defined according to the rules in the XPath data model.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getSchemaType

          SchemaType getSchemaType()

      Get the type annotation of the current attribute or element node, or atomic value. The result of this method is undefined unless the most recent event was START_ELEMENT, ATTRIBUTE, or ATOMIC_VALUE.
      Returns:
        the type annotation.
      Since:
        9.4; replace the method getTypeAnnotation() which returned the integer fingerprint of the type

    - #### getAtomicValue

          AtomicValue getAtomicValue()

      Get an atomic value. This call may be used only when the last event reported was ATOMIC_VALUE. This indicates that the PullProvider is reading a sequence that contains a free-standing atomic value; it is never used when reading the content of a node.
      Returns:
        the atomic value

    - #### getSourceLocator

          Location getSourceLocator()

      Get the location of the current event. For an event stream representing a real document, the location information should identify the location in the lexical XML source. For a constructed document, it should identify the location in the query or stylesheet that caused the node to be created. A value of null can be returned if no location information is available.
      Returns:
        the SourceLocator giving the location of the current event, or null if no location information is available

    - #### getUnparsedEntities

          java.util.List<UnparsedEntity> getUnparsedEntities()

      Get a list of unparsed entities.
      Returns:
        a list of unparsed entities, or null if the information is not available, or an empty list if there are no unparsed entities. Each item in the list will be an instance of `UnparsedEntity`